/*-
 * Copyright (c) 2015
 *      Bill Paul <wpaul@windriver.com>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Bill Paul.
 * 4. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY Bill Paul AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL Bill Paul OR THE VOICES IN HIS HEAD
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

/* $Id: dds_out.h,v 1.6 2015/12/31 20:25:36 wpaul Exp $ */

extern void dds_out_init (void);
extern void dds_out_send (void);

#define DDS_REG_RX	1
#define DDS_REG_TX	2

/* Analog Devices AD9835 programming values */

#define AD_CMD_PHASE_REGWR	0x0000	/* Write 16 phase bits to register */
#define AD_CMD_PHASE_DFRWR	0x1000	/* Write 8 phase bits to defer reg */
#define AD_CMD_FREQ_REGWR	0x2000	/* Write 16 freq bits to register */
#define AD_CMD_FREQ_DFRWR	0x3000	/* Write 8 freq bits to defer reg */
#define AD_CMD_PHASESRC_SEL	0x4000
#define AD_CMD_FREQSRC_SEL	0x5000
#define AD_CMD_BOTHSRC_SEL	0x6000

#define AD_DST_FREQ0_BYTE0	0x0000
#define AD_DST_FREQ0_BYTE1	0x0100
#define AD_DST_FREQ0_BYTE2	0x0200
#define AD_DST_FREQ0_BYTE3	0x0300
#define AD_DST_FREQ1_BYTE0	0x0400
#define AD_DST_FREQ1_BYTE1	0x0500
#define AD_DST_FREQ1_BYTE2	0x0600
#define AD_DST_FREQ1_BYTE3	0x0700
#define AD_DST_PHASE0_BYTE0	0x0800
#define AD_DST_PHASE0_BYTE1	0x0900
#define AD_DST_PHASE1_BYTE0	0x0A00
#define AD_DST_PHASE1_BYTE1	0x0B00
#define AD_DST_PHASE2_BYTE0	0x0C00
#define AD_DST_PHASE2_BYTE1	0x0D00
#define AD_DST_PHASE3_BYTE0	0x0E00
#define AD_DST_PHASE3_BYTE1	0x0F00

#define AD_CTRL_SELSRC		0x8000
#define AD_CTRL_SELSRC_SYNC	0x2000
#define AD_CTRL_SELSRC_SELSRC	0x1000

#define AD_CTRL_INIT		0xC000
#define AD_CTRL_INIT_SLEEP	0x2000
#define AD_CTRL_INIT_RESET	0x1000
#define AD_CTRL_INIT_CLR	0x0800

#define AD_SET_FREQ0		0x3000210032002300
#define AD_SET_FREQ1		0x3400250036002700
